package org.ow2.util.pool.impl.enhanced.api.basic;


/**
 * @author Gael Lalire
 */
public class CreatePoolItemException extends Exception {

    private static final long serialVersionUID = 6925951282630413069L;

    private Long brokenTime;

    public CreatePoolItemException(final Long brokenTime) {
        this.brokenTime = brokenTime;
    }

    public CreatePoolItemException(final Long brokenTime, final String message) {
        super(message);
        this.brokenTime = brokenTime;
    }

    public CreatePoolItemException(final Long brokenTime, final Throwable cause) {
        super(cause);
        this.brokenTime = brokenTime;
    }

    public CreatePoolItemException(final Long brokenTime, final String message, final Throwable cause) {
        super(message, cause);
        this.brokenTime = brokenTime;
    }

    /**
     * @return the broken time, if null then the factory will be forever broken
     */
    public Long getBrokenTime() {
        return brokenTime;
    }

}
